DEF VAR sp-companycode    AS CHAR NO-UNDO.
DEF VAR cVesselConversion AS CHAR NO-UNDO.
DEF VAR cOldVessel        AS CHAR NO-UNDO FORMAT "X(12)".
DEF VAR cNewVessel        AS CHAR NO-UNDO FORMAT "X(12)".
DEF VAR iLoop             AS INT  NO-UNDO.
DEF VAR iMoves            AS INT  NO-UNDO.
DEF VAR lOk               AS LOG  NO-UNDO.

DEF FRAME a .

sp-companycode    = "ROW".
cVesselConversion = '-,EB148-10'
                  + ',--1,EBA28-10'
                  + ',--2,EB365-10'
                  + ',--3,EBD35-10'
                  + ',--4,EBD36-10'
                  + ',--5,EBB40-10'
                  + ',--6,'
                  + ',--7,EB430-10'
                  + ',--8,WB428-10'
                  + ',--9,EB456-10'
                  .

DO  iLoop = 1 TO NUM-ENTRIES(cVesselConversion) BY 2 WITH FRAME a:
  cOldVessel = ENTRY(iLoop,cVesselConversion).
  cNewVessel = ENTRY(iLoop + 1,cVesselConversion).
  lOk        = FALSE.
  iMoves     = 0.
  IF cNewVessel <> "" AND cOldVessel <> ""
  THEN DO:
    RUN ecUpdateVessel (OUTPUT lOk).
    IF lOk
    THEN RUN ecUpdateMoves (OUTPUT iMoves).
  END.
  DISPL lOk cOldVessel cNewVessel iMoves.
END.

PROCEDURE ecUpdateVessel:
  DEF OUTPUT PARAMETER plOk AS LOG NO-UNDO.
  
  DEF BUFFER b-ec-vessel FOR ec-vessel.
  
  DISABLE TRIGGERS FOR LOAD OF b-ec-vessel.

  DO TRANSACTION:
    FIND ec-vessel WHERE
         ec-vessel.companycode = sp-companycode
     AND ec-vessel.vesselcode  = cOldVessel
         NO-LOCK NO-ERROR.
    
    FIND b-ec-vessel WHERE
         b-ec-vessel.companycode = sp-companycode
     AND b-ec-vessel.vesselcode  = cOldVessel
         EXCLUSIVE NO-ERROR.
    
    IF NOT AVAIL b-ec-vessel
    THEN plOk = FALSE.
    ELSE DO:
      IF AVAIL ec-vessel AND ec-vessel.vesselnr <> b-ec-vessel.vesselnr
      THEN plOk = FALSE.
      ELSE plOk = TRUE.
    END.
    
    IF plOk
    THEN DO:
      b-ec-vessel.vesselcode  = cNewVessel.
    END.
  END.
  

END PROCEDURE.

PROCEDURE ecUpdateMoves:
  DEF OUTPUT PARAMETER piMoves AS INT NO-UNDO.
  
  DEF BUFFER b-ec-container_history FOR ec-container_history.
  
  DO TRANSACTION:
    FOR EACH b-ec-container_history EXCLUSIVE WHERE
             b-ec-container_history.companycode = sp-companycode
         AND b-ec-container_history.vesselcode  = cOldVessel
             USE-INDEX vesselcode:
      b-ec-container_history.vesselcode = cNewVessel.
      piMoves = piMoves + 1.
    END.
  END.

END PROCEDURE.

